// Demo 3: AimPracticeA.java
//
//   Simple Java GunSight Aiming Application
//   Uses GunSight class, illustrates using objects
//   from a separate class we have written
//
//   Copyright 1999 by Charles W. Neville

// Note: This is the same as the CS 151 AimPractice.java demo, except
//       that this is an Application rather than an Applet.  Because
//       of security restrictions on Applets, you are going to have
//       to get used to writing Applications.

import java.awt.*;
import java.awt.event.*;
import SimpleGunSight;  // If we are going to use the SimpleGunSight 
                        // class, we need to import it.

import CloseAndExit;  // Ditto CloseAndExit class.
                      // We need the CloseAndExit class so we can close
                      // ourself gracefully when the user clicks our 
                      // close box.

public class AimPracticeA
  extends Frame implements ActionListener {

  TextField vertical, horizontal;
  Label verticalLabel, horizontalLabel;
  Button fire;
  SimpleGunSight sight;

  boolean firePressed = false;

  // Constructor: simply builds application Frame
  public AimPracticeA() {

     setLayout(new FlowLayout());  // this is the simplest layout, the
                                   // one used by default by Applets.
                                   // The default layout for Frames is
                                   // not suitable for much.
     
     addWindowListener(new CloseAndExit());  // Register an instance of 
                                             // CloseAndExit as a window 
                                             // event listener.  This is
                                             // all we have to do to
                                             // close gracefully!
     verticalLabel   = new Label("Vertical Coords ");
     add(verticalLabel);
     vertical = new TextField(5);
     vertical.setText("150");
     vertical.addActionListener(this);
     add(vertical);

     horizontalLabel = new Label("Horizontal Coords ");
     add(horizontalLabel);
     horizontal = new TextField(5);
     horizontal.setText("200");
     horizontal.addActionListener(this);
     add(horizontal);

     fire = new Button("Fire");
     fire.addActionListener(this);
     add(fire);

     // call the Constructor for our GunSight class
     sight = new SimpleGunSight();

   } // Constructor AimPracticeA()

   // draw sight and maybe laser cannon tracer line
   public void paint(Graphics g) {

      g.setColor(Color.black);

      sight.drawSight(g);

      if(firePressed) {
        fireLaserCannon(g);
        firePressed = false;
      }

   } // paint

   // fire laser cannon by drawing cannon tracer line,
   // sorry, no sound effects in deep space!
   void fireLaserCannon(Graphics g) {

      int x, y;

      x = sight.getX();  y = sight.getY();
      g.setColor(Color.red);
      g.drawLine(200, 350, x, y);  // cannon tracer line
      g.setColor(Color.black);
   }
      
   // handle action events
   public void actionPerformed(ActionEvent e) {

      // use object identity to decide which object
      // generated ActionEvent, and take appropriate
      // action
      if(e.getSource() == vertical) {
         sight.setY(Integer.parseInt(vertical.getText()));
      }
      else if(e.getSource() == horizontal) {
         sight.setX(Integer.parseInt(horizontal.getText()));
      }
      else if(e.getSource() == fire) {
         firePressed = true;
      }
   
      repaint();

   } // actionPerformed

   // remember, all Applications have to have a main()!!!
   public static void main(String[] args) {

      AimPracticeA apa = new AimPracticeA();  
                             // bootstrap ourselves into existence!

      apa.setSize(400, 350);  // set our size
      apa.setVisible(true);   // make ourselves visible

   } // main()

} // class AimPracticeA
